#####################################################################
# Copyright (c) 2012, Impulse Accelerated Technologies, Inc.
# All Rights Reserved.
#
#####################################################################


proc CopySoftwareFiles {name srcdir dstdir} {
	# each project gets its own sw sub-directory under destination export_sw dir
	set swDestDir [file join $dstdir export_sw $name]

	# copy SW files to destination directory
	file mkdir $swDestDir
	foreach f [glob -nocomplain -type f $srcdir/*] {
		file copy -force $f $swDestDir
	}
# TODO: copy generated initializtion code with software? (or will it just be there ready for copy?)
	return
	# all copied/generated source code is now in the export directory for glob'ing
	# initialize variable values table with what will be needed by embedded Tcl scripts
	global EmbeddedTclVars
	array unset EmbeddedTclVars
	set EmbeddedTclVars(AppName) "$name"
	# copy project files and generate any from template files with embedded Tcl
	copyDirAndGenerateEmbeddedTclFiles $swSrcDir $swDestDir
	# copy generated files to export target dir
	copyDirAndGenerateEmbeddedTclFiles [file join $srcdir export] $swDestDir
}

proc CopyHardwareFiles {name srcdir dstdir} {

	set hwSrcDir "$psp_top::PspHdlBaseDir/export"
	set hwDestDir $dstdir 

	# copy generated files from 'hw' to places in hwDestDir keeping track of files to 
	#  add to synthesis project
	# hw/lib/* -> ip/impulse_lib
	# hw/* -> ip/{ArchName}_module
	# TODO: userip HDL files
	set hwLibFiles [list]
	set hwFiles [list]
	set genHwDestDir [file join $hwDestDir ip/${name}_module/ ]
	file mkdir $genHwDestDir
	set libHwDestDir [file join $hwDestDir ip/impulse_lib/ ]
	file mkdir $libHwDestDir
	# generated HDL files
	foreach f [glob -nocomplain -type f $srcdir/*] {
		lappend hwFiles [file tail $f] 
		file copy -force $f $genHwDestDir
	}

	# impulse lib files
	#puts "libHwDestDir = $libHwDestDir"
	foreach f [glob -nocomplain -type f $srcdir/lib/*] {
		lappend hwLibFiles [file tail $f] 
		file copy -force $f $libHwDestDir
	}

	# generated floating point VHDL files
	foreach f [glob -nocomplain -type f $srcdir/lib/gen/*.vhd] {
		lappend hwLibFiles [file tail $f] 
		file copy -force $f $libHwDestDir
	}
	foreach f [glob -nocomplain -type f $srcdir/lib/gen/*.hex] {
		lappend hwLibFiles [file tail $f] 
		file copy -force $f $libHwDestDir
	}
	
	# don't copy these, just add to list, they'll be copied during last copyDirAndGenerateEmbeddedTclFiles
	# generated HDL wrapper files
	foreach f [glob -nocomplain -type f $srcdir/export/hdl/impulse_lib/*] {
		lappend hwLibFiles [file tail $f] 
	}
	# PSP specific HDL impulse lib files
	foreach f [glob -nocomplain -type f $hwSrcDir/hdl/impulse_lib/*] {
		lappend hwLibFiles [file tail $f] 
	}
	
	#puts "CopyHardwareFiles():hwLibFiles = $hwLibFiles"
	#puts "CopyHardwareFiles():hwFiles = $hwFiles"

	# initialize variable values table with what'll be needed by embedded Tcl scripts
	global EmbeddedTclVars
	array unset EmbeddedTclVars
	set EmbeddedTclVars(ArchName) "$name"
	set EmbeddedTclVars(hwLibFiles) $hwLibFiles
	# copy gnerated project files and generate any from template files with embedded Tcl
	copyDirAndGenerateEmbeddedTclFiles $srcdir/export $hwDestDir
	# copy project files and generate any from template files with embedded Tcl
	copyDirAndGenerateEmbeddedTclFiles $hwSrcDir $hwDestDir
	
	# copy software driver files and generate any from template files with embedded Tcl
	copyDirAndGenerateEmbeddedTclFiles $srcdir/HAL $genHwDestDir
}

