# Copyright (c) 2012, Impulse Accelerated Technologies, Inc.
# All Rights Reserved.

namespace eval psp_top {
	set PSPcommon "$env(IMPULSEC_HOME)/Architectures/PSPcommon"
	set PspHdlBaseDir "$env(IMPULSEC_HOME)/Architectures/VHDL/Altera/AvalonGeneric"
	set PspSwBaseDir "$env(IMPULSEC_HOME)/Architectures/Altera/AvalonGeneric"

	# load files according to caller:
	set CallerExecutable [file tail [info nameofexecutable]]
	#puts "# psp_top.tcl: psp_top::CallerExecutable = $CallerExecutable"
	
	if { [string first "-tb" $argv] < 0 } {
		# HW generation
		set IsGeneratingTestbench 0
	} else {
		# testbench generation
		set IsGeneratingTestbench 1
	}
}	;# end of namespace psp_config_lib

# load necessary Tcl scripts according to caller
if { $psp_top::CallerExecutable == "impulse_arch.exe" || $psp_top::CallerExecutable == "impulse_arch" } {
	source "$psp_top::PSPcommon/tcl/embeddedTclFile.tcl"
	source "$psp_top::PSPcommon/tcl/psp_genbus_lib.tcl"
	source "$psp_top::PspHdlBaseDir/genbus.tcl"
	source "$psp_top::PspHdlBaseDir/avalon_genbus_lib.tcl"
} elseif { $psp_top::CallerExecutable == "impulse_lib.exe" || $psp_top::CallerExecutable == "impulse_lib" } {
	source "$psp_top::PSPcommon/tcl/embeddedTclFile.tcl"
	source "$psp_top::PSPcommon/tcl/psp_genbus_lib.tcl"
	# if more genlib's need to be supported, then they should be specified in XML 
	#  and source psp_top.tcl from the genlib.tcl instead
	source "$psp_top::PspSwBaseDir/NiosII/genlib.tcl"
} elseif { $psp_top::CallerExecutable == "impulse_export.exe" || $psp_top::CallerExecutable == "impulse_export" } {
	source "$psp_top::PSPcommon/tcl/embeddedTclFile.tcl"
	source "$psp_top::PspSwBaseDir/export.tcl"
} else {
	puts "psp_top.tcl:ERROR:Unknown callerExecutable$psp_top::CallerExecutable"
	exit -1
}

puts "################################################"
puts "# psp_top.tcl: Loaded by:$psp_top::CallerExecutable"
puts "################################################"

################################################################################
# Environment is setup and necessary Tcl files are loaded, caller executable
#  will now make appropriate callback(s) such as GenerateBUS and GenerateLIB
################################################################################

# successful return code for source'ing of this file
return 0
